

#include "./include/ChangeOutputFile.cxx"
#include "./include/DAQSTART.cxx"
#include "./include/EasirocParameter.cxx"
#include "./include/CamacParameter.cxx"
#include "./include/UDPSTART.cxx"
#include "./include/Monitor.cxx"

TGMainFrame*MainFrame 		= new TGMainFrame();
TGCheckButton*check_easiroc = new TGCheckButton();
TGCheckButton*check_camac 	= new TGCheckButton();
TGCheckButton*check_camac_adc1 	= new TGCheckButton();
TGCheckButton*check_camac_adc2 	= new TGCheckButton();
TGCheckButton*check_camac_adc3 	= new TGCheckButton();
TGCheckButton*check_camac_adc4 	= new TGCheckButton();
TGCheckButton*check_camac_tdc 	= new TGCheckButton();

TGTextButton*Button_EASROCMONITOR
								= new TGTextButton();
TGTextEntry*entry				= new TGTextEntry();
TGTextEntry*entry_comment	= new TGTextEntry();
TGTextEntry *entry_RunNo		= new TGTextEntry();
TGTextEntry*entry_ADC1  		= new TGTextEntry();
TGTextEntry*entry_ADC1ch		= new TGTextEntry();
TGTextEntry*entry_ADC2  		= new TGTextEntry();
TGTextEntry*entry_ADC2ch		= new TGTextEntry();
TGTextEntry*entry_ADC3  		= new TGTextEntry();
TGTextEntry*entry_ADC3ch		= new TGTextEntry();
TGTextEntry*entry_ADC4  		= new TGTextEntry();
TGTextEntry*entry_ADC4ch		= new TGTextEntry();
TGTextEntry*entry_TDC   		= new TGTextEntry();
TGTextEntry*entry_TDCch 		= new TGTextEntry();
TGTextEntry*entry_EvNo		= new TGTextEntry();
TGNumberEntry*entry_monitor	= new TGNumberEntry();
TGComboBox *entry_HGPreAmp	= new TGComboBox();
TGComboBox *entry_LGPreAmp 	= new TGComboBox();

int HGPreAmp_easiroc, LGPreAmp_easiroc, timeSSH_easiroc;


void guitest(){
char name[1000],cmd[1000];

//**********************************
// main frame
//**********************************
MainFrame = new TGMainFrame(gClient->GetRoot(),10,10,kMainFrame | kVerticalFrame);
MainFrame->SetName("MainFrame");
MainFrame->SetLayoutBroken(kTRUE);

//###########################################################################################
//		
//###########################################################################################
//**********************************
// comment
//**********************************
label_comment = new TGLabel(MainFrame,"comment");
	MainFrame->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(8,8,45,16);

TGFont*ufont_comment;
ufont_comment = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_comment;
GCValues_t valcomment;
uGC_comment = gClient->GetGC(&valcomment, kTRUE);

entry_comment = new TGTextEntry(MainFrame, new TGTextBuffer(14),
	-1,uGC_comment->GetGC(),ufont_comment->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
entry_comment->SetText("no comment");
entry_comment->Resize(272,entry_comment->GetDefaultHeight());
entry_comment->MoveResize(56,8,272,20);



//**********************************
// DAQ button
//**********************************
TGTextButton *Button_DAQ = new TGTextButton(MainFrame,"DAQ START",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_DAQ->MoveResize(10,32,80,20);
Button_DAQ->Connect("Clicked()",0,0,"DAQSTART()");

TGTextButton *Button_STOP = new TGTextButton(MainFrame,"STOP",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_STOP->MoveResize(10,54,80,20);
Button_STOP->Connect("Clicked()",0,0,"DAQSTOP()");

TGTextButton *Button_QUIT = new TGTextButton(MainFrame,"QUIT",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_QUIT->MoveResize(10,76,80,20);
Button_QUIT->Connect("Clicked()",0,0,"CloseWin()");


//**********************************
// check box
//**********************************
check_easiroc = new TGCheckButton(MainFrame,"EASIROC");
check_easiroc->SetState(kButtonDown);
check_easiroc->MoveResize(112,32,111,17);

check_camac = new TGCheckButton(MainFrame,"CAMAC");
check_camac->SetState(kButtonDown);
check_camac->MoveResize(112,48,117,17);


//**********************************
// run No.
//**********************************
	//定義、配置
	label_comment = new TGLabel(MainFrame,"Run No.");
	MainFrame->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(110,78,45,16);

	//フォント設定
	TGFont*ufont_RunNo;
	ufont_RunNo = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_RunNo;
	GCValues_t valRunNo;
	uGC_RunNo = gClient->GetGC(&valRunNo, kTRUE);
	entry_RunNo = new TGTextEntry(MainFrame, new TGTextBuffer(14),
	-1,uGC_RunNo->GetGC(),ufont_RunNo->GetFontStruct(),
	kSunkenFrame | kOwnBackground);

	//ワークディレクトリ位置確認
	ifstream ifs("./setup/WorkDIR.txt");
	ifs>>name;
	ifs.close();

	//ワークディレクトリ内のラン番号テキスト閲覧
	// -> ラン番号の取得
	sprintf(name,"%srunnum.txt",name);
	ifstream ifs(name);
	ifs>>name;
	ifs.close();

	entry_RunNo->SetText(name);
	entry_RunNo->SetAlignment(kTextRight);
	entry_RunNo->Resize(272,entry_RunNo->GetDefaultHeight());
	entry_RunNo->MoveResize(160,76,40,20);


//**********************************
// event No.
label_comment = new TGLabel(MainFrame,"event");
	MainFrame->AddFrame(label_comment,
		new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	label_comment->MoveResize(220,78,30,16);

TGFont*ufont_EvNo;
ufont_EvNo = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_EvNo;
GCValues_t valEvNo;
uGC_EvNo = gClient->GetGC(&valEvNo, kTRUE);

entry_EvNo = new TGTextEntry(MainFrame, new TGTextBuffer(14),
	-1,uGC_EvNo->GetGC(),ufont_EvNo->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
ifstream ifs("./setup/EventNum.txt");
	ifs>>name;
	ifs.close();
entry_EvNo->SetText(name);
entry_EvNo->SetAlignment(kTextRight);
entry_EvNo->Resize(272,entry_EvNo->GetDefaultHeight());
entry_EvNo->MoveResize(260,76,40,20);


//###########################################################################################
//                           M O N I T O R 
//###########################################################################################
TGGroupFrame *frame_monitor = new TGGroupFrame(MainFrame,"monitor");
frame_monitor->SetLayoutBroken(kTRUE);

//**********************************
//monitor run online-histogram
//**********************************
	// LABEL text
	label = new TGLabel(frame_monitor,"monitor: run number");
	label->SetTextJustify(36);
	label->SetMargins(0,0,0,0);
	label->SetWrapLength(-1);
	frame_monitor->AddFrame(label, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
	label->MoveResize(8,20,120,20);

	TGFont*ufont_monitor;
	ufont_monitor = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_monitor;
	GCValues_t valmonitor;
	uGC_monitor = gClient->GetGC(&valmonitor, kTRUE);

	// BOX number & +/-
	entry_monitor = new TGNumberEntry(frame_monitor,
						(Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
	entry_monitor->SetNumber(1);
	frame_monitor->AddFrame(entry_monitor,
				new TGLayoutHints(kLHintsLeft |	kLHintsTop,2,2,2,2));
	entry_monitor->MoveResize(140,20,50,20);

	// BUTTON
		TGTextButton *Button_monitor =
			new TGTextButton(frame_monitor,"HIST",-1,
			TGTextButton::GetDefaultGC()(),
			TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
		Button_monitor->MoveResize(200,20,50,20);
		Button_monitor->Connect("Clicked()",0,0,"monitor_hist()");

	// BUTTON
		TGTextButton *Button_monitor2 =
			new TGTextButton(frame_monitor,"TRACK",-1,
			TGTextButton::GetDefaultGC()(),
			TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
		Button_monitor2->MoveResize(260,20,50,20);
		Button_monitor2->Connect("Clicked()",0,0,"monitor_track()");


//**********************************
// EASIROC HV supply START
//**********************************
		Button_UDP = new TGTextButton(frame_monitor,
			"UDP START",-1,TGTextButton::GetDefaultGC()(),
			TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
		Button_UDP->MoveResize(8,45,100,20);
		Button_UDP->Connect("Clicked()",0,0,"UDP()");


//*************************************
// Change EASIROC Analog OUTPUT ch
//*************************************
		Button_EASROCMONITOR = new TGTextButton(frame_monitor,
			"EASIROC MONITOR",-1,TGTextButton::GetDefaultGC()(),
			TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
		Button_EASROCMONITOR->MoveResize(8,70,100,20);
		Button_EASROCMONITOR->Connect("Clicked()",0,0,"EASIROCMONITOR()");


//**********************************
//  TEMP. Motnitor
//**********************************
//		Button_TEMPMONITOR = new TGTextButton(frame_monitor,
//			"TEMP. MONITOR",-1,TGTextButton::GetDefaultGC()(),
//			TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
//		Button_TEMPMONITOR->MoveResize(120,45,100,20);
//		Button_TEMPMONITOR->Connect("Clicked()",0,0,"TEMPMONITOR()");




//**********************************
// GroupFrame
//**********************************
TGGroupFrame *frame_conf = new TGGroupFrame(MainFrame,"configuration");
frame_conf->SetLayoutBroken(kTRUE);

//**********************************
// output file DIR dispray
label_DIR = new TGLabel(frame_conf,"DIR:");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(5,20,50,16);

TGFont*ufont_DIR;
ufont_DIR = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
TGGC*uGC_DIR;
GCValues_t val_filename;
uGC_DIR = gClient->GetGC(&val_filename, kTRUE);
entry = new TGTextEntry(frame_conf, new TGTextBuffer(14),
	-1,uGC_DIR->GetGC(),ufont_DIR->GetFontStruct(),
	kSunkenFrame | kOwnBackground);
entry->SetAlignment(kTextLeft);
ifstream ifs("./setup/WorkDIR.txt");
ifs>>name;
ifs.close();
entry->SetText(name);
entry->Resize(272,entry->GetDefaultHeight());
entry->MoveResize(50,16,220,20);

Button = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button->MoveResize(281,20,50,16);
Button->Connect("Clicked()",0,0,"config_fileIO()");


//**********************************
// EASIROC conf.
//**********************************
label_DIR = new TGLabel(frame_conf,"EASIROC PARAMETER:");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(10,40,125,16);

// PreAmp High Gain 
/*label_DIR = new TGLabel(frame_conf,"PreAmp HG");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(25,60,80,16);

TGComboBox *entry_HGPreAmp = new TGComboBox(frame_conf,-1,kHorizontalFrame | kSunkenFrame | kOwnBackground);
entry_HGPreAmp->AddEntry("150  ",1);
entry_HGPreAmp->AddEntry(" 75  ",2);
entry_HGPreAmp->AddEntry(" 50  ",3);
entry_HGPreAmp->AddEntry(" 37.5",4);
entry_HGPreAmp->AddEntry(" 30  ",5);
entry_HGPreAmp->AddEntry(" 15  ",6);
entry_HGPreAmp->Resize(256,20);
HGPreAmp_easiroc = GetHGPreAmp_easiroc();//########
entry_HGPreAmp->Select(HGPreAmp_easiroc);
frame_conf->AddFrame(entry_HGPreAmp, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
entry_HGPreAmp->MoveResize(120,60,80,20);

Button_HGPreAmp = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_HGPreAmp->MoveResize(281,60,50,16);
Button_HGPreAmp->Connect("Clicked()",0,0,"SetHGPreAmp_easiroc()");

// PreAmp Low Gain 
label_DIR = new TGLabel(frame_conf,"PreAmp LG");
	label_DIR->SetMargins(0,0,0,0);
	label_DIR->MoveResize(25,80,80,16);

TGComboBox *entry_LGPreAmp = new TGComboBox(frame_conf,-1,kHorizontalFrame | kSunkenFrame | kOwnBackground);
entry_LGPreAmp->AddEntry("150  ",1);
entry_LGPreAmp->AddEntry(" 75  ",2);
entry_LGPreAmp->AddEntry(" 50  ",3);
entry_LGPreAmp->AddEntry(" 37.5",4);
entry_LGPreAmp->AddEntry(" 30  ",5);
entry_LGPreAmp->AddEntry(" 15  ",6);
entry_LGPreAmp->Resize(256,20);
HGPreAmp_easiroc = GetHGPreAmp_easiroc();//########
entry_LGPreAmp->Select(HGPreAmp_easiroc);
frame_conf->AddFrame(entry_LGPreAmp, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
entry_LGPreAmp->MoveResize(120,80,80,20);

Button_LGPreAmp = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button_LGPreAmp->MoveResize(281,80,50,16);
Button_LGPreAmp->Connect("Clicked()",0,0,"SetLGPreAmp_easiroc()");
*/

//**********************************
// CAMAC PARAMETER
//**********************************
	label = new TGLabel(frame_conf,"CAMAC PARAMETER:");
	label->SetMargins(0,0,0,0);
	label->MoveResize(30,80,125,16);
	label = new TGLabel(frame_conf,"ON/OFF");
	label->SetMargins(0,0,0,0);
	label->MoveResize(60,96,40,16);
	label = new TGLabel(frame_conf,"mod");
	label->SetMargins(0,0,0,0);
	label->MoveResize(120,96,60,16);
	label = new TGLabel(frame_conf,"ch");
	label->SetMargins(0,0,0,0);
	label->MoveResize(200,96,60,16);

	int check[5],mod[5],TotCh[5];
	ifstream ifs("./setup/CamacParameter.txt");
	for(int i=0;i<5;i++) ifs>>check[i]>>mod[i]>>TotCh[i];
	ifs.close();

	Button = new TGTextButton(
		frame_conf,
		"OK",-1,
		TGTextButton::GetDefaultGC()(),
		TGTextButton::GetDefaultFontStruct(),
		kRaisedFrame);
	Button->MoveResize(281,96,50,16);
	Button->Connect("Clicked()",0,0,"SetCmacacParameter1()");

	int li[4]={10,70,120,200};

	//ADC1****************************************
	label = new TGLabel(frame_conf,"ADC1");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],110,30,10);
	// check box
	check_camac_adc1 = new TGCheckButton(frame_conf,"");
	if(check[0]==1) check_camac_adc1->SetState(kButtonDown);
	else check_camac_adc1->SetState(kButtonUp);
	check_camac_adc1->MoveResize(li[1],110,10,10);
	//font
	TGFont*ufont_ADC;
	ufont_ADC = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_ADC;
	GCValues_t val_ADC;
	uGC_ADC = gClient->GetGC(&val_ADC, kTRUE);
	//folum -mod
	entry_ADC1 = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC1->SetAlignment(kTextRight);
	sprintf(name,"%d",mod[0]);
	entry_ADC1->SetText(name);
	entry_ADC1->Resize(272,entry->GetDefaultHeight());
	entry_ADC1->MoveResize(li[2],110,40,15);
	//folum -ch
	entry_ADC1ch = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC1ch->SetAlignment(kTextRight);
	sprintf(name,"%d",TotCh[0]);
	entry_ADC1ch->SetText(name);
	entry_ADC1ch->Resize(272,entry->GetDefaultHeight());
	entry_ADC1ch->MoveResize(li[3],110,40,15);


	//ADC2****************************************
	label = new TGLabel(frame_conf,"ADC2");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],125,30,10);
	// check box
	check_camac_adc2 = new TGCheckButton(frame_conf,"");
	if(check[1]==1) check_camac_adc2->SetState(kButtonDown);
	else check_camac_adc2->SetState(kButtonUp);
	check_camac_adc2->MoveResize(li[1],125,10,10);
	//font
/*	TGFont*ufont_ADC;
	ufont_ADC = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_ADC;
	GCValues_t val_ADC;
	uGC_ADC = gClient->GetGC(&val_ADC, kTRUE);*/
	//folum -mod
	entry_ADC2 = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC2->SetAlignment(kTextRight);
	sprintf(name,"%d",mod[1]);
	entry_ADC2->SetText(name);
	entry_ADC2->Resize(272,entry->GetDefaultHeight());
	entry_ADC2->MoveResize(li[2],125,40,15);
	//folum -ch
	entry_ADC2ch = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC2ch->SetAlignment(kTextRight);
	sprintf(name,"%d",TotCh[1]);
	entry_ADC2ch->SetText(name);
	entry_ADC2ch->Resize(272,entry->GetDefaultHeight());
	entry_ADC2ch->MoveResize(li[3],125,40,15);


	//ADC3****************************************
	label = new TGLabel(frame_conf,"ADC3");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],140,30,10);
	// check box
	check_camac_adc3 = new TGCheckButton(frame_conf,"");
	if(check[2]==1) check_camac_adc3->SetState(kButtonDown);
	else check_camac_adc3->SetState(kButtonUp);
	check_camac_adc3->MoveResize(li[1],140,10,10);
	//font
	/*TGFont*ufont_ADC;
	ufont_ADC = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_ADC;
	GCValues_t val_ADC;
	uGC_ADC = gClient->GetGC(&val_ADC, kTRUE);*/
	//folum -mod
	entry_ADC3 = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC3->SetAlignment(kTextRight);
	sprintf(name,"%d",mod[2]);
	entry_ADC3->SetText(name);
	entry_ADC3->Resize(272,entry->GetDefaultHeight());
	entry_ADC3->MoveResize(li[2],140,40,15);
	//folum -ch
	entry_ADC3ch = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC3ch->SetAlignment(kTextRight);
	sprintf(name,"%d",TotCh[2]);
	entry_ADC3ch->SetText(name);
	entry_ADC3ch->Resize(272,entry->GetDefaultHeight());
	entry_ADC3ch->MoveResize(li[3],140,40,15);


	//ADC4****************************************
	label = new TGLabel(frame_conf,"ADC4");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],155,30,10);
	// check box
	check_camac_adc4 = new TGCheckButton(frame_conf,"");
	if(check[3]==1) check_camac_adc4->SetState(kButtonDown);
	else check_camac_adc4->SetState(kButtonUp);
	check_camac_adc4->MoveResize(li[1],155,10,10);
	//font
	/*TGFont*ufont_ADC;
	ufont_ADC = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_ADC;
	GCValues_t val_ADC;
	uGC_ADC = gClient->GetGC(&val_ADC, kTRUE);*/
	//folum -mod
	entry_ADC4 = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC4->SetAlignment(kTextRight);
	sprintf(name,"%d",mod[3]);
	entry_ADC4->SetText(name);
	entry_ADC4->Resize(272,entry->GetDefaultHeight());
	entry_ADC4->MoveResize(li[2],155,40,15);
	//folum -ch
	entry_ADC4ch = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_ADC->GetGC(),ufont_ADC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_ADC4ch->SetAlignment(kTextRight);
	sprintf(name,"%d",TotCh[3]);
	entry_ADC4ch->SetText(name);
	entry_ADC4ch->Resize(272,entry->GetDefaultHeight());
	entry_ADC4ch->MoveResize(li[3],155,40,15);


/*Button = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button->MoveResize(281,140,50,16);
Button->Connect("Clicked()",0,0,"SetCmacacParameter1()");*/


	//TDC
	label = new TGLabel(frame_conf,"TDC");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],170,30,10);

	// check box
	check_camac_tdc = new TGCheckButton(frame_conf,"");
	if(check[4]==1) check_camac_tdc->SetState(kButtonDown);
	else check_camac_tdc->SetState(kButtonUp);
	check_camac_tdc->MoveResize(li[1],170,10,10);

	TGFont*ufont_TDC;
	ufont_TDC = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC*uGC_TDC;
	GCValues_t val_TDC;
	uGC_TDC = gClient->GetGC(&val_TDC, kTRUE);
	entry_TDC = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_TDC->GetGC(),ufont_TDC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_TDC->SetAlignment(kTextRight);
	sprintf(name,"%d",mod[4]);
	entry_TDC->SetText(name);
	entry_TDC->Resize(272,entry->GetDefaultHeight());
	entry_TDC->MoveResize(li[2],170,40,15);
	
/*label = new TGLabel(frame_conf,"Total Ch.");
	label->SetMargins(0,0,0,0);
	label->MoveResize(li[0],160,60,16);
*/

	entry_TDCch = new TGTextEntry(frame_conf, new TGTextBuffer(14),
		-1,uGC_TDC->GetGC(),ufont_TDC->GetFontStruct(),
		kSunkenFrame | kOwnBackground);
	entry_TDCch->SetAlignment(kTextRight);
	sprintf(name,"%d",TotCh[4]);
	entry_TDCch->SetText(name);
	entry_TDCch->Resize(272,entry->GetDefaultHeight());
	entry_TDCch->MoveResize(li[3],170,40,15);
	

/*Button = new TGTextButton(frame_conf,"OK",-1,TGTextButton::GetDefaultGC()(),TGTextButton::GetDefaultFontStruct(),kRaisedFrame);
Button->MoveResize(281,160,50,16);
Button->Connect("Clicked()",0,0,"SetCmacacParameter1()");*/




   frame_conf->SetLayoutManager(new TGVerticalLayout(frame_conf));
   frame_conf->Resize(336,200);
   MainFrame->AddFrame(frame_conf, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   frame_conf->MoveResize(336,0,336,200);
//  TGNumberEntry *fNumberEntry1068 = new TGNumberEntry(MainFrame, (Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);

/*   fNumberEntry1068->SetName("fNumberEntry1068");
   MainFrame->AddFrame(fNumberEntry1068, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1068->MoveResize(72,140,53,20);*/


frame_monitor->SetLayoutManager(new TGVerticalLayout(frame_monitor));
frame_monitor->Resize(336,200);
MainFrame->AddFrame(frame_monitor, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
frame_monitor->MoveResize(10,100,320,100);
//TGNumberEntry *fNumberEntry1068 = new TGNumberEntry(MainFrame, (Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);

/*   fNumberEntry1068->SetName("fNumberEntry1068");
   MainFrame->AddFrame(fNumberEntry1068, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1068->MoveResize(72,140,53,20);*/


/*   TGNumberEntry *fNumberEntry1251 = new TGNumberEntry(MainFrame, (Double_t) 0,6,-1,(TGNumberFormat::EStyle) 5);
   fNumberEntry1251->SetName("fNumberEntry1251");
   MainFrame->AddFrame(fNumberEntry1251, new TGLayoutHints(kLHintsLeft | kLHintsTop,2,2,2,2));
   fNumberEntry1251->MoveResize(72,160,53,20);*/

   MainFrame->SetMWMHints(kMWMDecorAll,
                        kMWMFuncAll,
                        kMWMInputModeless);
   MainFrame->MapSubwindows();

   MainFrame->Resize(MainFrame->GetDefaultSize());
   MainFrame->MapWindow();
   MainFrame->Resize(683,196);
}

void CloseWin(){
cout<<"close\n";
MainFrame->CloseWindow();
}
