//*****************
//  main func.
//*****************
void track(){
  gROOT->LoadMacro("./include/ProcEvent.C");
  char name[100],cmd[100];
  
  //ワークディレクトリ検索
  ifstream ifs("./setup/MonitorFile.txt");
  ifs>>cmd;
  ifs.close();
  ifstream ifs("./setup/WorkDIR.txt");
  ifs>>name;
  ifs.close();
  
  //文字検索
  // ***.cmd ... CAMAC データ
  // ***.esd ... EASIROC データ
  // ***.ecd ... CAMAC + EASIROC データ
  sprintf(name,"%sdata/%s",name,cmd);
  if(StrString(name,"cmd")==0 &&
     StrString(name,"esd")==0 &&
     StrString(name,"ecd")==0){
    cout<<"no file\n";
    return;
  }
  
  //拡張子ごとに起動
  if(StrString(name,"cmd")!=0)// CAMAC DATA offline monitor
    camac_offline_tracking_monitor(name);
  //camac_offline_monitor(name);
  //return;
  
  //if(StrString(name,"esd")!=0)// EASIROC DATA offline monitor
  //easiroc_offline_monitor(name);
  //return;
  
  //if(StrString(name,"ecd")!=0)// EASIROC + CAMAC DATA offline monitor
  //easiroc_camac_offline_tracking_monitor(name);
  //easiroc_camac_offline_monitor(name);
  
  return;
}


//****************************
//   文字列部分一致検索
//****************************
int StrString(const char *s1, const char *s2){
int n;
 n = strlen(s2);                            /* 文字列s2の長さを求める */
 while (1) {
   s1 = strchr(s1, s2[0]);                /* s2の先頭の１文字を探す */
   if(s1 == NULL)                        /* 見つからなければ */
     return 0;									/* NULLを返す */
   if(strncmp(s1, s2, n) == 0)            /* 見つかったらn文字比較 */
     return 1;//(char *)s1;                 /* 一致したらポインタを返す */
   s1++;    /* ポインタを進めて */         /* s1はconstを付けて宣言 */
 }
}



//*****************
// CAMAC offline tracker
//****************
void camac_offline_tracking_monitor(char*name){
  gStyle->SetOptStat(1001110);
  ifstream ifs(name);//input file name
  double x;
  PSPMT=new TH2F("PSPMT","PSPMT",10,-1,8,10,-1,8);
  //adc[64]=new TH1S();
  
  /*for(int i=0;i<64;i++){
    sprintf(name,"adc%d",i);
    adc[i]=new TH1S(name,name,4096,0,4096);}
    tdc[16] =new TH1S();
    for(int i=0;i<16;i++){
    sprintf(name,"tdc%d",i);
    tdc[i]=new TH1S(name,name,4096,0,4096);}
  */
  int list[64]={
    0,0,0,0, 0,0,0,0, 1,2,9,10, 17,18,25,26,
    33,34,41,42, 49,50,3,4, 11,12,19,20, 27,28,35,36,
    43,44,51,52, 5,6,13,14, 21,22,29,30, 37,38,45,46,
    0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0
  };
  int Threshold[64]={
    120,120,120,120, 120,120,120,120, 125,125,125,125, 125,125,125,125,
    100,100,100,100, 110,110,100,100, 100,100,100,100, 100,100,105,100,
    135,135,135,140, 135,135,142,140, 150,150,140,140, 135,135,135,135
    1,1,1,1, 1,1,1,1, 1,1,1,1, 1,1,1,1
  };

  int dmy,maxadcch,maxtdcch;
  int j=0;
  while(!ifs.eof()){
    j++;
    for(int i=0;i<64;i++){
      ifs>>x;
      if(x>Threshold[i] && (i>=7 && i<=47))
	PSPMT->Fill(list[i]%8,7-list[i]/8);
    }
    for(int i=0;i<16;i++){
      ifs>>x;
    }
    //tdc[i]->Fill(x);}
    if(j%100==0)cout<<"."<<flush;
  }
  ifs.close();
  
  
  c1=new TCanvas("c1");
  //c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
  //c1->Divide(2,2);
  //c1->cd(1);
  PSPMT->Draw("colz");
  
  return;
  
}



//************************************
//EASIROC + CAMAC Offline Monitor
//************************************
#include "./include/TrackingMonitorThreshold.hh"
void easiroc_camac_offline_tracking_monitor(char*name){
	gStyle->SetOptStat(1001110);
	int n;

	ifstream ifs(name, std::ios::binary);//ファイルオープン
	if(!ifs.is_open()){//もし開かなかったら終了
		cout << "\nno file" << endl;
		return;
	}
	PSPMT=new TH2F("PSPMT","PSPMT",11,-1,9,11,-1,9);
	SFT=new TH2F("SFT","SFT",14,-1,12,14,-1,12);
	SFTx=new TH1F("SFTx","SFTx",13,-1,12);
	SFTy=new TH1F("SFTy","SFTy",13,-1,12);

	int adc[64],adc_c[64],tdc_c[16];
	while(!ifs.eof()){
		int data;
		ifs.read((char*)&data, sizeof(int));
		if((unsigned int)data == 0xffffea0c){
			ifs.read((char*)&data, sizeof(int));
			int NofWord = data & 0xffff;
			ifs.read((char*)&data, sizeof(int));
			//cout<<"degbug";
	
			for(int i = 0; i<NofWord; ++i){
				ifs.read((char*)&data, sizeof(int));
				if(0x81 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					adc[channel]=val;//->Fill(val);
					//chhist->Fill(i-1,val);
				}
				if(0x60 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					adc[channel+32]=val;//->Fill(val);
					//chhist->Fill(i-1,val);
				}
	        }

			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x71 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[i]=val;//->Fill(val);
			    	}
				}
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x72 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[16+i]=val;//->Fill(val);
		    	}
			}
			//cout<<adc_c[0]<<" "<<flush;

			//cout<<"degbug";
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x73 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[32+i]=val;//->Fill(val);
		    	}
			}
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x74 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[48+i]=val;//->Fill(val);
		    	}
			}
			for(int i = 0; i<16; ++i){
				ifs.read((char*)&data, sizeof(int));
		       if(0x75 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					tdc_c[i]=val;//->Fill(val);
				}
			}
			for(int i=0;i<64;i++){
				if(adc_c[i] > (double)threPMT(i)){
					PSPMT->Fill(i%8,8-i/8);
				}
			}
			for(int i=0;i<10;i++){
				for(int j=0;j<10;j++){
					if(adc[i]>threMPPC(i) && adc[j+10]>threMPPC(j+10)){
						SFT->Fill(i,10-j);
						SFTx->Fill(i);
						SFTy->Fill(10-j);
					}
				}
			}
			n++;
		}
		if(n%100==0)cout<<"."<<flush;
	}

//	return;
//cout<<"degbug";

c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(2,2);
c1->cd(1);
PSPMT->Draw("colz");
c1->cd(2);
SFT->Draw("colz");
c1->cd(3);
SFTx->Draw();
c1->cd(4);
SFTy->Draw();
return;
}

//****************************
//CAMAC Offline Monitor
//****************************
void camac_offline_monitor(char*name){
gStyle->SetOptStat(1001110);
ifstream ifs(name);//input file name
double x;
adc[64]=new TH1S();
for(int i=0;i<64;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1S(name,name,4096,0,4096);}
tdc[16] =new TH1S();
for(int i=0;i<16;i++){
	sprintf(name,"tdc%d",i);
	tdc[i]=new TH1S(name,name,4096,0,4096);}

int dmy,maxadcch,maxtdcch;
int j=0;
while(!ifs.eof()){
	j++;
	for(int i=0;i<64;i++){
		ifs>>x;
		adc[i]->Fill(x);}
	for(int i=0;i<16;i++){
		ifs>>x;
		tdc[i]->Fill(x);}
	if(j%100==0)cout<<"."<<flush;}
ifs.close();
	
c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",
                        0, 0, "ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(8,10);
for(int i=0;i<64;i++){
	c1->cd(i+1);
	adc[i]->Draw();}
for(int i=0;i<16;i++){
	//c2->cd(i+1);
	c1->cd(i+65);
	tdc[i]->Draw();}
	return;
}

//************************************
//EASIROC Offline Monitor
//************************************
void easiroc_offline_monitor(char*name){
gStyle->SetOptStat(1001110);
int n;

ifstream ifs(name, std::ios::binary);//ファイルオープン
if(!ifs.is_open()){//もし開かなかったら終了
	cout << "\nno file" << endl;
	return;}

adc[64]=new TH1F();//EASIROC MPPC
	for(int i=0;i<64;i++){
	sprintf(name,"adc%d",i);
	adc[i]=new TH1F(name,name,4096,0,4095);}
	chhist = new TH2F("chhist","",64,0-0.5,64-0.5,1500,500,2000);

while(!ifs.eof()){
	int data;
	ifs.read((char*)&data, sizeof(int));
	if((unsigned int)data == 0xffffea0c){
	ifs.read((char*)&data, sizeof(int));
	int NofWord = data & 0xffff;
	ifs.read((char*)&data, sizeof(int));
	for(int i = 0; i<NofWord; ++i){
		ifs.read((char*)&data, sizeof(int));
		if(0x81 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel]->Fill(val);
			chhist->Fill(i-1,val);}
		if(0x60 == ((data >> 24) & 0xff)){
			int channel = (data >> 16) & 0xff;
			int val = data & 0xfff;
			adc[channel+32]->Fill(val);
			chhist->Fill(i-1,val);}}
        n++;}
if(n%100==0)cout<<"."<<flush;
}
c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(8,8);
for(int i=0;i<64;i++){
	c1->cd(i+1);
	adc[i]->Draw();}

c2=new TCanvas("c2");
chhist->Draw("colz");
return;
}



//************************************
//EASIROC + CAMAC Offline Monitor
//************************************
void easiroc_camac_offline_monitor(char*name){
	gStyle->SetOptStat(1001110);
	int n;

	ifstream ifs(name, std::ios::binary);//ファイルオープン
	if(!ifs.is_open()){//もし開かなかったら終了
		cout << "\nno file" << endl;
		return;
	}
	adc_c[64]=new TH1F();//CAMAC ADC
	for(int i=0;i<64;i++){
		sprintf(name,"adc_c%d",i);
		adc_c[i]=new TH1F(name,name,4096,0,4096);
	}
	tdc_c[16]=new TH1F();//CAMAC TDC
	for(int i=0;i<16;i++){
		sprintf(name,"tdc_c%d",i);
		tdc_c[i]=new TH1F(name,name,4096,0,4095);
	}
	adc[64]=new TH1F();//EASIROC MPPC
	for(int i=0;i<64;i++){
		sprintf(name,"adc%d",i);
		adc[i]=new TH1F(name,name,4096,0,4095);
	}
	chhist = new TH2F("chhist","",64,0-0.5,64-0.5,1500,500,2000);

	while(!ifs.eof()){
		int data;
		ifs.read((char*)&data, sizeof(int));
		if((unsigned int)data == 0xffffea0c){
			ifs.read((char*)&data, sizeof(int));
			int NofWord = data & 0xffff;
			ifs.read((char*)&data, sizeof(int));
	
			for(int i = 0; i<NofWord; ++i){
				ifs.read((char*)&data, sizeof(int));
				if(0x81 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					adc[channel]->Fill(val);
					chhist->Fill(i-1,val);
				}
				if(0x60 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					adc[channel+32]->Fill(val);
					chhist->Fill(i-1,val);
				}
	        }

			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x71 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[i]->Fill(val);
			    	}
				}
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x72 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[16+i]->Fill(val);
		    	}
			}
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x73 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[32+i]->Fill(val);
		    	}
			}
			for(int i = 0; i<16; ++i){
			  	ifs.read((char*)&data, sizeof(int));
			   if(0x74 == ((data >> 24) & 0xff)){
			   		int channel = (data >> 16) & 0xff;
			    	int val = data & 0xfff;
			    	adc_c[48+i]->Fill(val);
		    	}
			}
			for(int i = 0; i<16; ++i){
				ifs.read((char*)&data, sizeof(int));
		       if(0x75 == ((data >> 24) & 0xff)){
					int channel = (data >> 16) & 0xff;
					int val = data & 0xfff;
					tdc_c[channel]->Fill(val);
				}
			}
			n++;
        }
		if(n%100==0)cout<<"."<<flush;
	}

c1=new TCanvas("c1");
c1->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c1->Divide(8,10);
for(int i=0;i<64;i++){
	c1->cd(i+1);
	adc_c[i]->GetXaxis()->SetRangeUser(0,2000);
	adc_c[i]->Draw();}
for(int i=0;i<16;i++){
	c1->cd(i+65);
	tdc_c[i]->Draw();}

c3=new TCanvas("c3");
c3->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)",0,0,"ProcEvent(Int_t,Int_t,Int_t,TObject*)");
c3->Divide(8,9);
for(int i=0;i<64;i++){
	c3->cd(i+1);
	adc[i]->Draw();}
//c4=new TCanvas("c4");
c3->cd(65);
chhist->Draw("colz");
return;
}
